# Template for Bug Issue

Please use this template if the issue that you are reporting is a (potential) bug in CV32E40P Documentation, RTL, Verification environment or Tools and Build system.

<br>**Note**: Please file bugs related to the CV32E40P User Manual and RTL in https://github.com/openhwgroup/cv32e40p.
<br>**Note**: Please file bugs related to the core-v-verif verification environment in https://github.com/openhwgroup/core-v-verif instead.
<br>**Note**: Please file bugs related to the GNU GCC compiler in https://github.com/openhwgroup/corev-gcc instead.
<br>**Note**: Please file bugs related to the LLVM compiler in https://github.com/openhwgroup/corev-llvm-project instead.
<br>**Note**: Please file bugs related to the binary utils and gdb in https://github.com/openhwgroup/corev-binutils-gdb instead.

## Bug Title
A clear and concise description of what the bug is.

### Component
Indicate the component in which you found a problem (and we will add the appropriate label):

**Component:Doc**: For issues in the Documentation (e.g. for README.md files)
**Component:RTL**: For issues in the RTL (e.g. for files in the rtl directory)
**Component:Verif**: For issues in the verification environment or test cases (e.g. for behavioral code, testbench, C code, etc.)
**Component:Tool-and-build**: For issues in the tool and build flow (e.g. Makefile, FuseSoc, etc.)

### Steps to Reproduce
Please provide:
1. git hash
2. Command line
3. Logfile and/or wave-dump info (screen shots can be useful)
